package com.huiju.estateagents.center.taUser.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.huiju.estateagents.base.ResponseBean;
import com.huiju.estateagents.center.taUser.entity.TaUser;
import com.huiju.estateagents.center.taUser.mapper.TaUserAuthMenuMapper;
import com.huiju.estateagents.center.taUser.mapper.TaUserMapper;
import com.huiju.estateagents.center.taUser.service.ITaUserAuthMenuService;
import com.huiju.estateagents.entity.SysMenu;
import com.huiju.estateagents.entity.TaRoleMenu;
import com.huiju.estateagents.mapper.TaRoleMenuMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * @author weicc
 * @Title: TaUserAuthMenuServiceImpl
 * @Description: TODO
 * @date 2019/9/21
 */
@Service
public class TaUserAuthMenuServiceImpl extends ServiceImpl<TaUserAuthMenuMapper, SysMenu> implements ITaUserAuthMenuService {


    @Autowired
    private TaUserAuthMenuMapper taUserAuthMenuMapper;
    @Autowired
    private TaRoleMenuMapper taRoleMenuMapper;
    @Autowired
    private TaUserMapper taUserMapper;

    /**
     * 根据用户id获取授权菜单
     * @param pageNum
     * @param pageSize
     * @param userId
     * @return
     */
    @Override
    public ResponseBean getMenuByUserId(Integer pageNum, Integer pageSize, String userId) {

        List<SysMenu> records = taUserAuthMenuMapper.sysMenuListByUserId(userId);
        return ResponseBean.success(records);
    }

    @Override
    public ResponseBean getAllMenu(Integer pageNum, Integer pageSize) {

        List<SysMenu> records = taUserAuthMenuMapper.sysMenuListByRoleId();

        QueryWrapper<TaRoleMenu> queryWrapper = new QueryWrapper();
        List<TaRoleMenu> taRoleMenus = taRoleMenuMapper.selectList(queryWrapper);

        for (SysMenu sysMenu : records){
            ArrayList<Integer> roles = new ArrayList<>();
            for (TaRoleMenu taRoleMenu : taRoleMenus){
                if (taRoleMenu.getMenuId().equals(sysMenu.getMenuId()) && !roles.contains(taRoleMenu.getRoleId())){
                    roles.add(taRoleMenu.getRoleId());
                }
            }
            sysMenu.setRoles(roles);
        }

        return ResponseBean.success(records);
    }

    @Override
    public ResponseBean updateUserAuthMenu(Integer userId, List<SysMenu> sysMenuList) {
        ResponseBean responseBean = new ResponseBean();

        // 人员
        TaUser taUser = taUserMapper.selectById(userId);
        if (null == taUser) {
            responseBean.addError("授权人不存在");
            return responseBean;
        }

        try{
            //授权菜单，先删除在新增
            taUserAuthMenuMapper.deleteUserAuthMenu(userId);
            taUserAuthMenuMapper.addUserAuthMenu(userId, sysMenuList);
            responseBean.addSuccess("操作成功");
            return  responseBean;
        }catch (Exception e){
            responseBean.addSuccess("操作失败");
            e.printStackTrace();
            return responseBean;
        }

    }

}
